/*
 * Copyright (C) 2010 SENJU Jiro
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <assert.h>
#include <stdio.h>
#include <string.h>

#ifndef PhBufferSize
#define PhBufferSize 16
#endif

int main(int argc, char *argv[])
{
	struct {
		FILE *fp;
		char buffer[PhBufferSize];
	} a[2];
	size_t sz;
	char *p;

	a[0].fp = fopen(argv[1], "w+");
	assert(a[0].fp);
	a[1].fp = fopen(argv[1], "r");
	assert(a[1].fp);

	memset(a[0].buffer, 'a', PhBufferSize);
	sz = fwrite(a[0].buffer, sizeof(*a[0].buffer), PhBufferSize, a[0].fp);
	assert(sz == PhBufferSize);
	sz = fread(a[1].buffer, sizeof(*a[1].buffer), PhBufferSize, a[1].fp);
	/* assert(sz == PhBufferSize); */
	p = "equivalent";
	if (memcmp(a[0].buffer, a[1].buffer, PhBufferSize))
		p = "different";
	printf("PhBufferSize %d, %zu bytes read, %s\n", PhBufferSize, sz, p);

	return 0;
}
