
Me := $(lastword ${MAKEFILE_LIST})
include var.mk
KVer = 34-rc6

Sq40LzmaGit = http://git.kernel.org/?p=linux/kernel/git/pkl/squashfs-lzma.git

all:
	@echo \- Get linux-2.6.${KVer} and extract it under a dir named ${Linux26}
	@echo \- Get squashfs4.0-lzma by \"make -f ${Me} download\"
	@echo \- Apply the patches to linux-2.6.${KVer} by \"make -f ${Me} apply\"
	@echo \- Build linux-2.6.${KVer} by \"cd ${Linux26} '&& make &&' make headers_install\" and reboot

clean:
	test ! -f sq40lzma-apply ||\
	echo sq40lzma.*.patch |\
	tr ' ' '\n' |\
	tac |\
	while read i; \
	do \
		test ! -f $${i} && continue; \
		patch -s -d ${Linux26} -p1 -R < $${i}; \
	done
	${RM} sq40lzma-apply

realclean: clean
	${RM} sq40lzma.*.patch sq40lzma-download

download apply: %: sq40lzma-%

########################################

sq40lzma-download: sq40lzma.commits
	n=1; \
	while read commit title; \
	do \
		wget --no-verbose \
			"${Sq40LzmaGit};a=commitdiff_plain;h=$${commit}" \
			-O sq40lzma.$${n}.patch; \
		n=$$(($${n} + 1)); \
	done < $<
	touch $@

sq40lzma-apply: sq40lzma-download
	for i in sq40lzma.*.patch; \
	do patch -s -d ${Linux26} -p1 < $${i}; \
	done
	touch $@
