
Me := $(lastword ${MAKEFILE_LIST})

Sq40ToolDir = sq4.0.wcvs/squashfs/squashfs-tools
# empty password
Cvs = cvs -d:pserver:anonymous:@squashfs.cvs.sourceforge.net:/cvsroot/squashfs
Lzma = lzma465
LzmaPath = downloads.sourceforge.net/sevenzip/${Lzma}.tar.bz2

all:
	@echo \- Download squashfs-tools and ${Lzma} by \"make -f ${Me} download\"
	@echo \- Build it by \"make -f ${Me} build\"

clean:
	-test -d ${Sq40ToolDir} && ${MAKE} -C ${Sq40ToolDir} $@

realclean: dir = downloads.sourceforge.net
realclean: clean
	${RM} -r sq4.0.wcvs ${Lzma} ${LzmaPath} sq40tools-download
	-test -d ${dir} && find ${dir} -depth -type d |\
	xargs -r rmdir --ignore-fail-on-non-empty

download: %: sq40tools-%
build: ${Sq40ToolDir}/mksquashfs

########################################

sq40tools-download:
	wget --no-verbose -x http://${LzmaPath}
	mkdir -p ${Lzma}
	tar -C ${Lzma} -xpjf ${LzmaPath} C
	mkdir -p sq4.0.wcvs
	cd sq4.0.wcvs && \
	${Cvs} login && \
	${Cvs} -z3 -Q co squashfs/squashfs-tools
	touch $@

${Sq40ToolDir}/mksquashfs: sq40tools-download
	${MAKE} -C ${Sq40ToolDir} LZMA_SUPPORT=1 LZMA_DIR=${CURDIR}/${Lzma}
